<template>
  <div class="liff">
    <v-app-bar
      color="primary"
      dense
      flat
      dark
    >
      <v-toolbar-title class="liff-header">
        ลงทะเบียน
      </v-toolbar-title>
    </v-app-bar>
    <v-container class="pt-0 pb-0">
      <v-row>
        <v-col cols="12">
          <div class="mt-8 text-primary text-title text-center">
            Step 2 of 2
          </div>
        </v-col>
        <v-col cols="12">
          <v-form>
            <v-text-field
              v-model="form.citizenid"
              class="pb-3"
              dense
              :rules="citizenidRules"
              label="เลขที่บัตรประชาชน"
              @keypress="citizenNumber($event, 13)"
            />
            <v-text-field
              v-model="form.email"
              class="pb-3"
              type="email"
              dense
              :rules="emailRules"
              label="อีเมล"
            />
            <v-text-field
              v-model="form.phone"
              class="pb-3"
              dense
              :rules="phoneRules"
              label="เบอร์โทรศัพท์"
              @keypress="onlyNumber($event, 10)"
            />
            <v-dialog
              ref="dialog"
              v-model="modal"
              persistent
              width="290px"
            >
              <template v-slot:activator="{ on }">
                <v-text-field
                  v-model="form.birthday"
                  label="วันเดือนปีเกิด"
                  prepend-icon="event"
                  readonly
                  class="set-birthday"
                  v-on="on"
                />
              </template>
              <v-date-picker v-model="form.birthday" :max="new Date().toISOString().substr(0, 10)" scrollable>
                <v-spacer />
                <v-btn text color="primary" @click="modal = false">
                  Cancel
                </v-btn>
                <v-btn text color="primary" @click="$refs.dialog.save(form.birthday)">
                  OK
                </v-btn>
              </v-date-picker>
            </v-dialog>
            <v-btn rounded color="primary" dark class="w-100 mt-10 my-btn" @click="register">
              ลงทะเบียน
            </v-btn>
            <div class="w-100 text-center my-btn text-primary" @click="back">
              ย้อนกลับ
            </div>
          </v-form>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script>
const REGEX_EMAIL = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
const REGEX_PHONE = /^[0]([0-9]{9})*$/
const REGEX_NUMBER = /^[0-9]*$/
export default {
  data () {
    return {
      form: {
        citizenid: this.$store.getters.getRegister.citizenid,
        email: this.$store.getters.getRegister.email,
        phone: this.$store.getters.getRegister.phone,
        birthday: this.$store.getters.getRegister.birthday
      },
      modal: false,
      citizenidValidated: false,
      emailValidated: false,
      phoneValidated: false,
      citizenidRules: [value => this.citizenidValidator(value)],
      emailRules: [value => this.emailValidator(value)],
      phoneRules: [value => this.phoneValidator(value)]
    }
  },
  methods: {
    phoneValidator (value) {
      this.phoneValidated = false
      if (value === '') {
        return 'กรอก'
      }
      if (REGEX_PHONE.test(value) && value.length === 10) {
        this.phoneValidated = true
        return true
      }
      return 'กรุณากรอกหมายเลขโทรศัพท์'
    },
    citizenidValidator (value) {
      this.citizenidValidated = false
      if (value === '') {
        return 'กรอก'
      }
      if (REGEX_NUMBER.test(value)) {
        this.citizenidValidated = true
        return true
      }
      return 'เลขที่บัตรประชาชนไม่ถูกต้อง'
    },
    emailValidator (value) {
      this.emailValidated = false
      if (value === '') {
        return 'กรอก'
      }
      if (REGEX_EMAIL.test(value)) {
        this.emailValidated = true
        return true
      }
      return 'อีเมลไม่ถูกต้อง'
    },
    citizenNumber (event, max) {
      if (!REGEX_NUMBER.test(event.key) || event.target.value.length === max) {
        return event.preventDefault()
      }
    },
    onlyNumber (event, max) {
      if (event.target.value.length === 0) {
        if (event.key !== '0') {
          return event.preventDefault()
        }
      } else if (!REGEX_NUMBER.test(event.key) || event.target.value.length === max) {
        return event.preventDefault()
      }
    },
    validate () {
      let validated = true
      const errors = []
      const validatorField = [
        'citizenid',
        'email',
        'phone'
      ]
      validatorField.forEach((field) => {
        if (this.form[field] === '') {
          validated = false
          errors.push(`${field} ไม่เป็นค่าว่าง`)
        }
      })
      if (!this.citizenidValidated) {
        validated = false
        errors.push('เลขที่บัตรประชาชนไม่ถูกต้อง')
      }
      if (!this.emailValidated) {
        validated = false
        errors.push('อีเมลไม่ถูกต้อง')
      }
      if (!this.phoneValidated) {
        validated = false
        errors.push('กรุณากรอกหมายเลขโทรศัพท์')
      }
      if (!validated) {
        this.$store.dispatch('setDialog', {
          isShow: true,
          title: 'กรอกข้อมูลไม่ถูกต้อง',
          message: errors
        })
      }
      return validated
    },
    back () {
      this.$router.push('/register')
    },
    register () {
      if (this.validate()) {
        this.$store.dispatch('setRegister', this.form)
        // this.$router.push('/register/done')
        // this.$axios.patch(`https://nuxt-tutor.firebaseio.com/members/${this.$store.getters.getLine.userId}/profile.json`, this.$store.getters.getRegister).then((res) => {
        //   this.$router.push('/register/done')
        // }).catch((e) => {
        //   // console.log(e)
        // })
        this.$axios.patch(`https://srisawad-yut1-line-bot.firebaseio.com/members/${this.$store.getters.getLine.userId}/profile.json`, this.$store.getters.getRegister).then((res) => {
          this.$router.push('/register/done')
        }).catch((e) => {
          // console.log(e)
        })
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  .v-form{
    padding: 0 10px;
  }
  .set-birthday{
    position: relative;
    ::v-deep .v-input__prepend-outer{
      position: absolute;
      right: 0
    }
  }
</style>
